unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, jpeg, ExtCtrls, FileCtrl, ComCtrls, ShellCtrls,
  ToolWin;

type
  TForm1 = class(TForm)
    dr3: TFileListBox;
    dr1: TShellTreeView;
    dr2: TScrollBox;
    sbar1: TStatusBar;
    ToolBar1: TToolBar;
    procedure dr3Change(Sender: TObject);
    procedure dr1Change(Sender: TObject; Node: TTreeNode);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure yyyy(Sender: TObject);
    procedure zzzz(Sender: TObject);
  end;

var
  Form1: TForm1;
  temp: string;
  using: integer;
  ktxt: array of tlabel;
  kpic: array of TImage;
  ktotal: integer;

implementation

{$R *.dfm}

procedure TForm1.dr3Change(Sender: TObject);
var
  bmp: TBitmap;
  jpeg: TJpegImage;
  rect: TRect;
  z, ax, kw, kh, xx, yy: integer;
  fname: string;
  fname2: string;
begin

  if ktotal > 0 then
  begin
    for z := 0 to ktotal - 1 do
    begin
      ktxt[z].Free;
      kpic[z].Free;
    end;
    ktotal := 0;
  end;

  if dr3.Items.Count > 0 then
  begin
    using := 1;
    dr2.Enabled := false;
    xx := 0;
    yy := 0;
    setlength(ktxt, dr3.Items.Count);
    setlength(kpic, dr3.Items.Count);
    bmp := TBitmap.Create;
    jpeg := TJpegImage.Create;

    for z := 0 to dr3.Items.Count - 1 do
    begin
      if using = 1 then
      begin

        fname := dr3.Items.Strings[z];
        fname2 := stringreplace(fname, '.jpg', '.bmp', [rfReplaceAll]);
        fname2 := stringreplace(fname2, '.JPG', '.bmp', [rfReplaceAll]);
        sbar1.Panels[0].Text := 'v' + fname + 'Ū';
        if fileexists(temp + fname2) = false then
        begin
          jpeg.LoadFromFile(dr1.Path + '\' + fname);
          if jpeg.Width > jpeg.Height then
          begin
            ax := (jpeg.Width div 80) + 1;
          end
          else
          begin
            ax := (jpeg.Height div 80) + 1;
          end;
          kw := jpeg.Width div ax;
          kh := jpeg.height div ax;
          rect.Left := 0;
          rect.Top := 0;
          rect.Right := kw - 1;
          rect.Bottom := kh - 1;
          bmp.Width := kw;
          bmp.Height := kh;
          bmp.Canvas.StretchDraw(rect, jpeg);
          bmp.SaveToFile(temp + fname2);
          application.ProcessMessages;
        end;

        ktxt[z] := tlabel.Create(form1);
        kpic[z] := TImage.Create(Form1);
        ktotal := ktotal + 1;

        ktxt[z].Parent := dr2;
        ktxt[z].Width := 100;
        ktxt[z].Height := 20;
        ktxt[z].Left := xx;
        ktxt[z].Top := yy + 80;
        ktxt[z].Tag := z;
        ktxt[z].Color := rgb(255, 255, 255);
        ktxt[z].OnClick := yyyy;
        ktxt[z].Caption := fname + '    ';

        kpic[z].Parent := dr2;
        kpic[z].Tag := z;
        kpic[z].OnClick := zzzz;
        kpic[z].Left := xx;
        kpic[z].Top := yy;
        kpic[z].Picture.LoadFromFile(temp + fname2);

        xx := xx + 100;
        if (xx > (dr2.Width - 100)) then
        begin
          xx := 0;
          yy := yy + 100;
        end;
      end;
    end;

    bmp.Free;
    jpeg.Free;
    sbar1.Panels[0].Text := '';
    dr2.VertScrollBar.Range := yy + 150;
    dr2.HorzScrollBar.Range := xx + 150;
    dr2.Enabled := true;
  end;

end;

procedure TForm1.dr1Change(Sender: TObject; Node: TTreeNode);
var z: integer;
begin
  using := 0;
  dr2.Enabled := true;
  sbar1.Panels[0].Text := '';
  application.ProcessMessages;
  dr3.Directory := dr1.Path;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  if directoryexists(getcurrentdir + '\temp') = false then
    createdir(getcurrentdir + '\temp');
  temp := getcurrentdir + '\temp\';
  using := 0;
  ktotal := 0;
end;

procedure TForm1.FormResize(Sender: TObject);
var
  xx, yy, z: integer;
begin
  xx := 0;
  yy := 0;
  if ktotal > 0 then
  begin
    dr2.VertScrollBar.Position := 0;
    for z := 0 to ktotal - 1 do
    begin
      ktxt[z].Left := xx;
      ktxt[z].Top := yy + 80;
      kpic[z].Left := xx;
      kpic[z].Top := yy;
      xx := xx + 100;
      if (xx > (dr2.Width - 100)) then
      begin
        xx := 0;
        yy := yy + 100;
      end;
    end;
    dr2.VertScrollBar.Range := yy + 150;
    dr2.HorzScrollBar.Range := xx + 150;
  end;
end;

procedure TForm1.yyyy(Sender: TObject);
var ak: integer;
begin
  ak := Tlabel(sender).Tag;
  if ktxt[ak].Color = rgb(255, 255, 255) then
  begin
    ktxt[ak].Color := rgb(200, 200, 255);
    dr3.Selected[ak] := true;
  end
  else
  begin
    ktxt[ak].Color := rgb(255, 255, 255);
    dr3.Selected[ak] := false;
  end;
end;

procedure TForm1.zzzz(Sender: TObject);
var ak: integer;
begin
  ak := TImage(sender).Tag;
  if ktxt[ak].Color = rgb(255, 255, 255) then
  begin
    ktxt[ak].Color := rgb(200, 200, 255);
    dr3.Selected[ak] := true;
  end
  else
  begin
    ktxt[ak].Color := rgb(255, 255, 255);
    dr3.Selected[ak] := false;
  end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var z: integer;
begin
  using := 0;
  if ktotal > 0 then
  begin
    for z := 0 to ktotal - 1 do
    begin
      ktxt[z].Free;
      kpic[z].Free;
    end;
    ktotal := 0;
  end;
end;

end.

